; Multi-IO 
; (c)W.Rmer 88-2017
;
; Bearbeitung:	05.11.2017	RTC OK
;		02.11.2017	RTC Schreibroutine ueber Buffer
;		01.11.2017	RTC-Routinen ueberarbeitet
;		02.05.2017	RTC-Test	
;		01.05.2017	RTC-Schaltung berichtigt
;		26.04.2017	Uhr schreiben/lesen
;		08.03.2017	Centronics
;		05.03.2017	com1/2 OK
;		03.03.2017	IO-byte OK
;		02.03.2017	Hardware neu aufgebaut
;		08.02.2017	com1,com2 nicht stabil ?
;		06.02.2017	Softwaregrundfunktionen
;				IO-Byte OK
;				Modusumschaltung OK
;				Centronics OK
;				paralelle Ausgabe OK
;		xx.04.1988	Hardware erstellt
;
; 2xV24
; 1xCentronics
; 1xparallele Ein/Ausgabe
; 
; Baudrate wird mit Timer 8254 erzeugt
; - com1 300Bd - 9600Bd TX/RX
; - com2 300Bd - 9600Bd TX/RX 
; 
; IO-Byte fuer die Konfiguration
;
;--------------------------------------------------------------------
;
; PIO1 Centronics und UNI-IO Kanal
;
pio1a	equ	03h	; Centronic's
pio1b	equ	13h	; frei
pio1c	equ	23h	; Steuerung Centronics
			; 	Bit 7 6 5 4 3 2 1 0
			;	    I I I I I I + + frei
			;	    I I I I I I
			;	    I I I I I + - - /Error	<--
			;	    I I I I + - - - INTRa	-->
			;	    I I I + - - - - Papierende	<--
			;	    I I + - - - - - BUSY	<--
			;	    I + - - - - - - /ACK	<--
			;	    + - - - - - - - /STROBE	-->		
						
pio1s	equ	33h	; Steuerregister
bap1	equ	0abh	; 1010 1011
			; Kanal A Modus 1 Ausgabe, Kanal B Modus 0 Eingabe
			; Kanal C Eingabe
;
; PIO2 IO-Byte und Systemuhr
;
pio2a	equ	43h	; 
			; RTC 58321 Daten
			; 	Bit 7 6 5 4 3 2 1 0
			;	    x x x x + + + + Daten 0-3	<->
			; Bit 4-7 frei
			;	      
pio2b	equ	53h	; IO-byte DIP-Schalter			<--		
			;
pio2c	equ	63h	; RTC 58321 Control
			; 	Bit 7 6 5 4 3 2 1 0
			;	    x x x I I I	I I
			;	    x x x I I I I + WR		-->
			;	    x x x I I I + - RD		-->
			;	    x x x I I + - - AD/WR	-->
			;	    x x x I + - - - CS		-->
			;	    x x x + - - - - Stop	-->
			; Bit 5-7 frei				-->
			;			
pio2s	equ	73h	; Steuerregister
			; Betriebsarten
bap2	equ	82h	; 1000 0010
			; Kanal A Modus 0 Ausgabe 
			; Kanal B Modus 0 Eingabe 
			; Kanal C lo Ausgabe
			; Kanal C hi Ausgabe
			;
bap2rdu	equ	92h	; 1001 0010
			; Kanal A Modus 0 Eingabe 
			; Kanal B Modus 0 Eingabe 
			; Kanal C lo Ausgabe
			; Kanal C hi Ausgabe
;
;--------------------------------------------------------------------
; Baudraten
; Wert als BCD, da Timer auf BCD Zaehler eingestellt wird
;
; fuer 6,144Mhz
;
; 9600Bd = 20h lowByte
; 4800Bd = 40h .
; 2400Bd = 80h .
; 1200Bd = 60h lowByte
;	   01h highByte
;--------------------------------------------------------------------

tim0	equ	83h	; BD-Rate fuer com1
tim1	equ	93h	; BD-Rate fuer com2 
tim2	equ	0a3h	; frei
tims	equ	0b3h	; Steuerregister
			; Timer0-2 als BCD-Zaehler, Rechteckgenerator,
			; erst Timewert-Low, dann Timewert-High laden
bati0	equ	37h	; 0011 0111 
bati1	equ	77h	; 0111 0111
bati2	equ	0b7h	; 1011 0111
;
com1s	equ	0c3h	; Steuerregister 
com1d	equ	0d3h	; Daten com1
bacom1	equ	15h	; Betriebsart (8bit,1Stop,ohne Paritaet, Takt/16)		;
;
com2s	equ	0e3h	; Steuerregister
com2d	equ	0f3h	; Daten com2
bacom2	equ	15h	; Betriebsart (8bit,1Stop,ohne Paritaet, Takt/16)
;
;
;-----------------------------------------------------------------------------
;
; Vorspann Parameterbereich
;
; Monitorprogramme  
;  
CI	EQU 0043h 	; CI 	Tastaturabfrage wartet auf Taste ASCII(A)    
CO	EQU 0049h  	; CO 	Bildschirmausgabe ASCII(C) Ziel (UPDATE)
LOM	EQU 004Fh	; LO 	Drucker Ueber RS232	          
CSTS	EQU 0052h  	; CSTS	Tastaturstatus Taste Z=0, k.Taste Z=1  	          
FILL	EQU 0085h  	; FILL  Speicher mit Konstante fuellen SRCBEG,SRCEND,DSTBEG        
COPYM	EQU 0088h  	; COPY  Speicherbereich verschieben 
onesec	EQU 001bh	; Wartezeit 1Sekunde
dely1	EQU 000bh	;           1ms
;
BELPOR	EQU 52h		; Port fuer Summer 
BYTFF	EQU 1Ah		; PORT FF auf Singel-Step-Modul
COMREG	EQU 48h		; Register Adressen
TRKREG	EQU 49h		; WD1770
SECREG	EQU 4Ah
DATREG	EQU 4BH
STATUS	EQU COMREG
CTRL	EQU 40H      
;
MOVID	EQU 1003h  	; Warmstart Videomonitor
BREAK	EQU 100Fh	; Unterbrechung mit CTRL-C
PARIN	EQU 1012h	;
STRING	EQU 1021h	; STRING
ERROR	EQU 1027h       ; Error Videomonitor
CLRVID	EQU 102Dh	; CLRVID  
CLRLIN	EQU 1030h	; CLRLIN        
CRSPOS	EQU 1033h	; CRSPOS         
CRSON	EQU 1036h 	; CRSON         
CRSOFF	EQU 1039h	; CRSOFF
BYTOT	EQU 103Fh	; BYTOT  (A) zweistellig darstellen Adresse (HL) 
ADROT	EQU 103ch	; (DE) vierstellig ausgeben
CRLF	EQU 137bh	; gibt CR/LF aus
;
; Exteren Programme
;
FDC	EQU 2000h	; Floppy 
EDIT	EQU 7000h	; Editor
ASS:	EQU 6000h	; Assembler
DISSK	EQU 6C00h	; Disassembler
;
STACK	EQU 2F00H	; 
TRAP	EQU 2F8Ch
RST55	EQU 2F98h
RST551	EQU 2F99h
;
HORDSP	EQU 2E50h	; 40/80 Zeichen pro Zeile
BEGIN	EQU 2E54h	; Anfangsadresse letzte Zeile
UPDATE	EQU 2E56h	; aktuelle Cursorposition
;
SRCBEG	EQU 2FBFh	; Startadresse
SRCEND	EQU 2FC1h	; Endadresse
DSTBEG	EQU 2FC3h	; Anfang Zieladresse/Parameter
DSTEND	EQU 2FC5h	; 
LINZ	EQU 2E54h
;
;uhrbuf:	equ 9800h	; Uhr-BCD
;ubfasc:	equ 982fh 	; Uhr-ASCII Ende des Buffers
;
;uhrbuf:	equ	2fdch	; Uhr-BCD
;ubfasc:	equ	2feah 	; Uhr-ASCII
;
VIDBEG	EQU 3000h	; Bildschirmadresse 	oben links
VIDEND	EQU 377Fh	; 			unten rechts
PRTFLG	EQU 37AFh	; 
RAMBEG	EQU 37B0h	; Anfang Parameterbereich Videomonitor

;
; Buffer Adressen
;
BATBUF	EQU 2D00h
FDCBUF	EQU 2F70h
CPYBUF	EQU 8000h
;
	ORG FDCBUF

TRKNR:	DS 1h		; Spurnummer
SECNR:  DS 1h		; Sektornummer
SIDNR:	DS 1h		; Seite 0/1
SELBYT: DS 1h		; SelectByte Bit1,2 = Laufwerksnummer
SELOUT: DS 1h
TRACK0: DS 4h
RWBEF:	DS 1h
DATADR:	DS 2h		; Buffer-Adresse r/w Sektoren
INTPRG:	DS 2h
RWSUB:	DS 1h
RWSUB1: DS 2h
HIBUF:	DS 2h
BUFDST: DS 1h
BUFSRC: DS 1h		; IM CF-Betrieb = Anzahl der Sektoren die übertragen werden
CPYEND: DS 1h
;
TIMOUT	EQU 32h		;
FQUARZ	EQU 06h		;
DLY100	EQU 13h		;
SECZAL	EQU 16		;
SECLDD	EQU 1		; 256 Bytes
;INTON	EQU 1Eh		; RST 5.5 freigeben
;INTOF	EQU 1Fh		; RST 5.5 sperren
;
;
;--------------------------------------------------------------------
;
;	Testroutinen, nach Reset muss immer der "Kaltstart"
;	aufgerufen werden damit alle Schnittstellen initialisiert werden.
;	Die Routinen werden mit beliebigem Tastendruck beendet.
;
	
	org 9000h		; Testadresse
;
kstart:	jmp 	kalt		; INI
	jmp	port		; Portadresse ansprechen
	jmp 	rdio		; IO-Byte lesen
	jmp 	para		; Test UNI Parallele Aus/Eingabe
	jmp	print		; Printkanal
	jmp 	comtx		; Byte senden an comx
	jmp 	comrx		; Byte lesen con comx
	jmp	ende		; Dummy
	jmp	uhrrd		; RTC lesen
	jmp	uhrstart	; Uhrstellen
	jmp	uhrasci		; Uhrzeit in ASCII
	jmp	uhrstrg		; Uhrzeit ausgeben
	jmp	0000h		;

ende: 	lxi  	h,meld10	;
	call 	string		;
	jmp  	movid		; zurueck zum Monitor
;
;----------------------------------------------------------
;
kalt:	call 	mioini		; IO-Bausteine initialisieren 
	call	fillb		; Buffer 8000h mit Ascii fuellen
	lxi  	h,meld1		;
	call 	string		;
	jmp 	rdio		; weiter mit IO-byte ausgeben
;
;----------------------------------------------------------
;
;		
mioini:	mvi	a,bap1		; PIO-Betriebsarten einstellen
	out	pio1s		;
	mvi	a,bap2		;
	out	pio2s		;
	xra	a		;
	out	pio2b		;
	out	pio2c		;
	;
	mvi	a,bacom1	; com1-Betriebsart
	out	com1s		;
	mvi	a,bacom2	; com2-Betriebsart
	out	com2s		;	
	;
	mvi	a,bati0		; Timer-Betriebsarten
	out	tims		;
	mvi	a,bati1		;
	out	tims		;
	mvi	a,bati2		;
	out	tims		;
	;
	lxi	d,0020h		; 9600Bd
	mov	a,e		; in Timer 0 laden
	out	tim0		;
	mov	a,d		;
	out	tim0		;
	;
	mov	a,e		; in Timer 1 laden
	out	tim1		;
	mov	a,d		;
	out	tim1		;
	;
	mov	a,e		; in Timer 2 laden
	out	tim2		;
	mov	a,d		;
	out	tim2		;
	;
	mvi	a,03h		; Reset UART1/2
	out	com1s		;
	out	com2s		;
	ret	
;
;
;--------------------------------------------------------------------
;	
port:	lxi  	h,meld6		;
	call 	string
	mvi	a,tim0		; Portadresse ausgeben
	call	bytot
	mvi	b,00		;
portl:	inr	b		;
	mov	a,b		;	
	out	tim0		;
	call	csts		;
	jz	portl		;
	jmp	ende
;
;----------------------------------------------------------
;		
rdio:	lxi  	h,meld3		; Meldung
	call 	string		;
rloop:	in	pio2b		; Befehl
	call 	bytot		; IO-Byte ausgeben
	mvi	c,0dh		; "CR"
	call	co		; ausgeben
	call	csts		;
	jz	rloop		; Schleife bis eine Taste betaetigt wird
	jmp  	ende		;	
;
;----------------------------------------------------------
;
; fuer com1/2 entsprechenden Port eintragen
;	
comtx:	lxi  	h,meld1		;
	call 	string

	call	mioini		;	
	lxi  	h,meld2
	call 	string
	;
comtl	mvi	c,41h		; "A"
	call	com2t		; <-- Port eintragen
	call	csts		;
	jz	comtl		; Schleife bis eine Taste betaetigt wird
	jmp  	ende		;
;
;----------------------------------------------------------
;
comrx:	lxi  	h,meld7		;
	call 	string

	call	mioini		;	
	lxi  	h,meld2
	call 	string
	;			; Daten empfangen
comrl	call	com2r		; <-- Port eintragen
	mov	c,a		;
	call	co		;
	call	csts		;
	jz	comrl		; Schleife bis eine Taste betaetigt wird
	jmp  	ende		;
;
;----------------------------------------------------------
;	
para:	lxi  	h,meld4		;
	call 	string
	mvi	b,00		;
	mvi	a,bap2		;
	out	pio2s		;
paral:	in	pio1a		; IO-Byte 	
	out	pio2b		; auf Parallel ausgeben
	call	csts		;
	jz	paral		;
	jmp	ende
;
;----------------------------------------------------------
;
; Druckt 64 ASCII Zeichen aus Speicher 8000h
;
print:	lxi  	h,meld5		;
	call 	string		;
	mvi	a,bap1		;
	out	pio1s		;
	lxi	h,8000h		; Quelle ASCII
	mvi	b,40		;
prtl:	in	pio1c		;
	ani	20h		; BUSY maskieren
	jnz	prtl		;
	mov	a,m		; Daten holen
	out	pio1a		; an Drucker
	dcr	b		;
	jz	prtend		; alle Zeichen
	inx	h		;
	jmp	prtl		;
	
prtend:	jmp	ende
;
; Buffer mit ASCII fuellen
fillb:	lxi	h,8000h		; Startadresse Buffer
	mvi	b,40h		;
	mvi	c,40h		;
filbl:	mov	m,c		;
	inx	h		;
	inr	c		;
	dcr	b		;
	jnz	filbl		;
	xra	a		;
	mov	m,a		; Ende String 00h
	ret			;	
	
;	
;--------------------------------------------------------------------	
;
; Byte v24 senden (C)
; wartet bis Empfaenger bereit ist
;
;	
com1t:	mvi 	a,55h		; 
	out 	com1s		; clk/16,8bit,1stop,ohne paritaet , RTS on
com1t_l: in 	com1s		; Warten bis Senderegister leer
	ani 	02H		;
	jz	com1t_l		;
	mov	a,c		;
	out 	com1d		; Daten senden
	ret			;	
;
com2t:	mvi 	a,55h		; 
	out 	com2s		; clk/16,8bit,1stop,ohne paritaet , RTS on
com2t_l: in 	com2s		; Warten bis Senderegister leer
	ani 	02H		;
	jz	com2t_l		;
	mov	a,c		;
	out 	com2d		; daten senden
	ret			;
;--------------------------------------------------------------------
;
;	
; Byte von V24 empfangen (A)
; wartet bis Zeichen vorhanden ist
;
com1r: mvi 	a,15h		; 
	out 	com1s		; clk/16,8bit,1stop,ohne paritaet , RTS off
com1r_l: IN 	com1s		; Warten bis Empfangsregister voll
	ANI 	01H		;
	jz  	com1r_l		; warten
	mvi 	a,55h		; RTS on
	out 	com1s		; 
	IN 	com1d		; Daten auslesen
	ret			;
;
com2r: mvi 	a,15h		; 
	out 	com2s		; clk/16,8bit,1stop,ohne paritaet , RTS off
com2r_l: IN 	com2s		; Warten bis Empfangsregister voll
	ANI 	01H		;
	jz  	com2r_l		; warten
	mvi 	a,55h		; RTS on
	out 	com2s		; 
	IN 	com2d		; Daten auslesen
	ret			;
;
;====================================================================
;
; Echzeituhr mit RTC-58321
;
; Betriebsarten PIO-2:
; bap2		= 82h	 1000 0010 (nach Reset)
;			 Kanal A Modus 0 Ausgabe 
;			 Kanal B Modus 0 Eingabe 
;			 Kanal C Ausgabe
; bap2rdu	= 92h	 1001 0010 (Uhr lesen)
;			 Kanal A Modus 0 Eingabe 
;			 Kanal B Modus 0 Eingabe 
;			 Kanal C Ausgabe
;
; Daten/Adressen ueber Port pio2a = 43h
; 	Bit 7 6 5 4 3 2 1 0
;	    x x x x + + + + Daten 0-3
; 
;       Bit 4-7 frei
;	      
; Steuerung ueber Port pio2c = 63h
;
; 	Bit 7 6 5 4 3 2 1 0
;	    x x x I I I	I I
;	    x x x I I I I + WR
;	    x x x I I I + - RD
;	    x x x I I + - - ADR-WR
;	    x x x I + - - - CS
;	    x x x + - - - - Stop
;
; RTC Registeradressen
; Adressen	Bedeutung		Gueltigkeit Datenbit 0-3
;
; 	3 2 1 0
; 0	0 0 0 0	= Sekunden-Einer	0 - 9
; 1	0 0 0 1	= Sekunden-Zehner	0 - 5
; 2	0 0 1 0	= Minuten-Einer		0 - 9
; 3	0 0 1 1	= Minuten-Zehner	0 - 5
; 4	0 1 0 0	= Stunden-Einer		0 - 9
; 5	0 1 0 1	= Stunden-Zehner	0 - 1 / 0 - 2 im 24Std-Modus
; 6	0 1 1 0	= Wochentag		0 - 6
; 7	0 1 1 1	= Tag-Einer		0 - 9
; 8	1 0 0 0	= Tag-Zehner		0 - 3 (D2 = 1 fuer Februar mit 29Tagen/sonst 28Tage)
; 9	1 0 0 1	= Monat-Einer		0 - 9
; A	1 0 1 0	= Monat-Zehner		0 - 1
; B	1 0 1 1	= Jahr-Einer		0 - 9
; C	1 1 0 0	= Jahr-Zehner		0 - 9
; 	
;
; Register: 	A,DE,HL
;		(B) : CTL-Maske fuer Port 2c
;		(C) : Adresse
;
; Portzuweisung (neus Label fuer die Systemuhrabfrage)
;
rtc_ctrl equ	pio2c
rtc_dat	equ	pio2a
;
;				; 7654 3210
;				;
rtccs	equ	18h		; 0001 1000	= RTC Selektieren und Zaehler-Stop
rtcwr	equ	19h		; 0001 1001	= RTC Datennibble schreiben
rtcrd	equ	1ah		; 0001 1010	= RTC Datennibble lesen
rtcawr	equ	1ch		; 0001 1100	= RTC Registeradresse schreiben
;
;
; Verzoegerungsroutine
;
dely10:	ret			; ca 10s
;	
;
;--------------------------------------------------------------------
; 
; RTC-58321 mit Daten laden
; diese muessen im uhrbuf vorher bereitgestellt werden
; siehe Registertabelle
;
uhrstart: xra	a		;
	lxi	h,meld8 	;
	call	string		; 
	
	lxi	h,uhrbuf	; 
	mvi	c,00h		; Zeiger fuer RTC-Register
	mvi	b,0dh		; Zaheler
	
	mvi	a,bap2		; Ausgabe
	out	pio2s		;
	
uhr_sl:	mov	a,m		; bit holen
	call	wr_rtc		;
	inx	h		; naechstes byte
	dcr	b		;
	jnz	uhr_sl		;
	xra	a		;
	out	rtc_ctrl	; RTC Steuereingaenge auf 0
	
	jmp	ende
;
;	
; wr_rtc Daten in RTC-58321 schreiben
;
wr_rtc:	push	psw			; daten retten
	mov	a,c			; Registeradresse
	out	rtc_dat			;
	call	dely10			;
	mvi	a,rtcawr		; Adress-Schreibimpuls
	out	rtc_ctrl		;
	call	dely10			;
	mvi	a,rtccs			;
	out	rtc_ctrl		;
	
	call	dely10			;
	pop	psw			;
	out	rtc_dat			; Wert in RTC laden
	mvi	a,rtcwr			; Schreibimpuls
	out	rtc_ctrl		;
	call	dely10			;
	mvi	a,rtccs			;
	out	rtc_ctrl		;	
	
	inr	c			; naechste Adresse einstellen
	ret


;--------------------------------------------------------------------
;
; Uhrzeit aus RTC-58321 lesen
;
; (c) Registeradresse	
; (hl) Bufferadresse
;
uhrrd:	lxi	h,meld9 	;
	call	string		;
	call	uhr_rd		;
	jmp	ende		;
	
uhr_rd:	lxi	h,uhrbuf	;
	mvi	c,00h		; Zeiger auf sek-einer
	mvi	a,bap2		; Ausgabe
	out	pio2s		;
	mvi	a,rtccs		; RTC stop/cs
	out	rtc_ctrl	;
urdloop: call	dely10		;
	mov	a,c		;Adresse einstellen
	out	rtc_dat		;
	
	call	dely10		;
	mvi	a,rtcawr	; Adresseschreiben
	out	rtc_ctrl	; ADR-Schreibimpuls
	call	dely10		;
	mvi	a,rtccs		;
	out	rtc_ctrl	;
	
	mvi	a,bap2rdu	; Kanal auf Eingabe umschalten
	out	pio2s
	
	call	dely10		; Register lesen
	mvi	a,rtcrd		;
	out	rtc_ctrl		;
	call	dely10		;
	in	rtc_dat		;
	ani	0fh		;oberes nibble ausblenden
	mov	m,a		;
	mvi	a,rtccs		;
	out	rtc_ctrl	; Leseimpuls beenden

	mvi	a,bap2		; Ausgabe
	out	pio2s		;
	
	inx	h		; naechste Adresse einstellen
	inr	c		;
	mov	a,c		; alle Register gelesen
	cpi	0dh		;
	jnz	urdloop		; nein
	
uhr_end: mvi	a,00h		; ende
	out	rtc_ctrl	; 
	ret			;


;-------------------------------------------------------------------------
;
;
uhrasci: call	uhr_asc			; Uhr lesen und in ASCII wandeln
	lxi	h,uascbuf		; Startadr. ASCIIBuffer
	call	string			; ausgeben
	jmp	ende
	
; Uhrzeit im ASCII-Buffer schreiben
; ! wird von rechts nach links eingetragen
;	
uhr_asc: CALL 	uhr_rd			; Uhr auslesen

uascw:	lxi	h,uascbuf		; Startadr. ASCII-Buffer
	lxi	d,15h			; Versatz
	dad	d			; HL auf ende ASCII-Buffer
	lxi	d,uhrbuf		;
        MVI M,00H			; 00h eintragen fuer String-Ende
        DCX H
        MVI M,68H			; ASCII "h" speichern
        CALL h2bcd			; Sekunden in ASCII Buffer 
        DCX H
        MVI M,3AH			; ASCII ":" (Trennzeichen)
        CALL h2bcd			; Minuten in ASCII Buffer
        DCX H
        MVI M,3AH			; ASCII ":" 
        CALL h2bcd			; Stunden in ASCII Buffer
        DCX H
        MVI M,3BH			; ASCII ";"
        LXI D,u_ja
        CALL h2bcd			; Jahr in ASCII Buffer
        DCX H
        MVI M,2EH			; ASCII "."
        LXI D,u_mo
        CALL h2bcd			; Monat in ASCII Buffer
        DCX H
        MVI M,2EH			; ASCII "."
        LXI D,u_ta
        CALL h2bcd			; Tag in ASCII Buffer
        DCX H
        MVI M,2CH			; ASCII ","
        DCX H
        PUSH H				;
        LXI H,wt_tab			; Tabelle fuer Wochentag 
        LDA u_wt			; Wochentag holen
        ANI 07H				; mit Tabelle umsetzen
        RLC				;
        MOV E,A				;
        MVI D,00H			;
        DAD D				;
        MOV E,M				;
        INX H				;
        MOV D,M				;
        POP H				;
        MOV M,E				;
        DCX H				;
        MOV M,D				;
        RET
;
;
uhrstrg: lxi	h,meld92 		;
	call	string			;
	
;
; h2bcd = hole 2 BCD-Werte aus Buffer
;	
h2bcd:  CALL hbcd			; 
;
hbcd:  DCX H				;
        LDAX D
        ADI 30H				; Gueltigkeit pruefen
        CPI 3AH
        JNC hbcd_er			; Fehler
        CPI 30H
        JNC hbcde			; OK Wert zueruckgeben
hbcd_er:  MVI A,2DH			; Wert ungueltig "-" zurueckgeben
;
hbcde:  MOV M,A
        INX D				; naechste Bufferadresse
        RET
;
; Wochentage ..oMiDiMoDrFaSoS
; 1 = Montag, 7 = Sonntag 
; Tage sind in umgekehrter Reihenfolge abgelegt
; weil der ASCII-Buffer von hinten nach vorn 
; aufgebaut wird
;
wt_tab:	DB 52h			; "R"                
	DB 45h                  ; "E" - Error
	DB 6Fh                 	; "o" - 
	DB 4Dh                 	; "M" - Montag
	DB 69h                 	; "i"
	DB 44h                  ; "D"
	DB 69h                  ; "i"
	DB 4Dh                  ; "M"
	DB 6Fh                  ; "o"
	DB 44h                  ; "D"
	DB 72h                  ; "r"
	DB 46h                  ; "F"
	DB 61h                  ; "a"
	DB 53h                  ; "S"
	DB 6Fh                  ; "o"
	DB 53h   		; "S"
;
;
;
;====================================================================
;
; Texte
;
meld1:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Multi-IO-Test"
	DB " INI"
	DB 0Dh			; 
	DB 00h
;
meld2:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Byte an comx"
	DB " senden"
	DB 0Dh			; 
	DB 00h
;
meld3:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "IO-Byte"
	DB " lesen"
	DB 0Dh			;
	DB 00h	 
	
meld4:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "UNI-Parllel"	;
	db " Ausgabe"
	DB 0Dh			; 	
	DB 00h	 
;
meld5:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Print"
	DB " Ausgabe"
	DB 0Dh			; 	
	DB 00h	 
	;
meld6:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "ADR"
	DB " Test"
	DB 0Dh			; 	
	DB 00h	 
	;
meld7:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Byte von comx"
	DB " empfangen"
	DB 0Dh			; 	
	DB 00h	 
	;
meld71:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Reset RTC"
	DB 0Dh			; 	
	DB 00h	
 	
meld8:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Uhr setzen"
	DB 0Dh			; 	
	DB 00h	 
;
meld9:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Uhr lesen"
	DB 0Dh			; 	
	DB 00h	 
;
meld91:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Uhr ASCII"
	DB 0Dh			; 	
	DB 00h	 
;
meld92:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Uhrzeit : "
	DB 0Dh			; 	
	DB 00h	 
;	
meld10:	DB 0Dh			; CR
	DB 0Ah			; LF     
	DB "Ende"
	DB 0Dh			;
	DB 00h	 
;	

;
;--------------------------------------------------------------------
	org	9800h		; Buffer fer Uhrzeit in BCD
	
uhrbuf: ds	1h		; Sek-Einer
	ds	1h		; Sek-Zehner
	ds	1h		; Min-Einer
	ds	1h		; Min-Zehner
	ds	1h		; Std-Einer
	ds	1h		; Std-Zehner
u_wt:	ds	1h		; Wochentag 1-7 Montag-Sonntag	
u_ta:	ds	1h		; Tag-Einer
	ds	1h		; Tag-Zehner
u_mo:	ds	1h		; Monat-Einer
	ds	1h		; Monat-Zehner
u_ja:	ds	1h		; Jahr-Einer
	ds	1h		; Jahr-Zehner	
	
	org	9820h		; Ende ASCII Buffer

uascbuf:	ds	16h	;	

	